
#include <arduino.h>
#include "softTimer.h"
#include "encoder.h"
#include "pinDefinitions.h"


class Encoder;
softTimer timer_en(5);


//**********************************************************
Encoder::Encoder(long sample_period_ms)
{
  pinMode(PIN_ENCODER_1 , INPUT_PULLUP);
  pinMode(PIN_ENCODER_2 , INPUT_PULLUP);
  timer_en.set(sample_period_ms);

}
//**********************************************************
void Encoder::modify( unsigned long *to_modify, unsigned long increment )
{
  output = to_modify;
  _increment = increment;
}

//**********************************************************
bool Encoder::moved()
{
  bool x = encoder_moved;
  encoder_moved = false;
  return x;
}
//**********************************************************
void  Encoder::update()
{
  if ( timer_en.event() )
  {
    //allgemein
    unsigned char encoder_a;
    unsigned char encoder_b;
    // 5ms since last check of encoder
    encoder_a = digitalRead(PIN_ENCODER_1 );    // Read encoder pins
    encoder_b = digitalRead(PIN_ENCODER_2 );

    //encoder
    if ((!encoder_a) && ( encoder_a_prev))
    { // A has gone from high to low
      encoder_moved = true;
      if (encoder_b)
      { // B is high so clockwise
        (* output) += _increment; // increase output
      }
      else
      { // B is low so counter-clockwise
        (* output) -= _increment;   // decrease output
      }
    }
    encoder_a_prev = encoder_a;     // Store value of A for next time
  }
}














